package com.qihoo360.mobilesafe.reward.presenter.base

import com.qihoo360.mobilesafe.reward.presenter.IPresenter
import com.qihoo360.mobilesafe.reward.presenter.view.IBaseView
import java.lang.RuntimeException

open class BasePresenter<V: IBaseView> constructor(): IPresenter<V> {


    var mView : V? = null

    private val isViewAttached : Boolean
      get() =  mView != null


    override fun attachView(mView: V) {
        this.mView = mView
    }

    override fun detachView() {
        this.mView = null
    }

    open fun checkViewAttached(){
        if (!isViewAttached)
            throw RuntimeException("mView is null")
    }

}