package com.qihoo360.mobilesafe.reward.ui.page

import android.content.BroadcastReceiver
import android.content.Context
import android.content.Intent
import android.content.IntentFilter
import android.os.Bundle
import android.util.Log
import android.view.KeyEvent
import android.view.View
import android.view.ViewGroup
import android.view.ViewStub
import android.widget.AdapterView
import com.qihoo360.apullsdk.apull.control.sync.ApullActionConst
import com.qihoo360.apullsdk.apull.control.sync.ApullActionConst.*
import com.qihoo360.apullsdk.export.ApullRewardInterfaceManager
import com.qihoo360.apullsdk.export.ApullRewardVideoInterface
import com.qihoo360.apullsdk.export.support.NewsExportArgsUtil.KEY_INITIAL_URL
import com.qihoo360.apullsdk.support.download.FileDownloadManager
import com.qihoo360.apullsdk.utils.NetUtil
import com.qihoo360.i.Factory
import com.qihoo360.i.IPluginManager
import com.qihoo360.mobilesafe.LocalBroadcastManagerC
import com.qihoo360.mobilesafe.RewardSDK
import com.qihoo360.mobilesafe.extension.setVisible
import com.qihoo360.mobilesafe.extension.toast
import com.qihoo360.mobilesafe.extension.tryCatch
import com.qihoo360.mobilesafe.reward.R
import com.qihoo360.mobilesafe.reward.RewardConfigHelper
import com.qihoo360.mobilesafe.reward.RewardConstant.Companion.ACTION_ACTIVITY_CHANGE_EVENT
import com.qihoo360.mobilesafe.reward.RewardConstant.Companion.ACTION_REWARD_AD_NEWS_H5_CREATE
import com.qihoo360.mobilesafe.reward.RewardConstant.Companion.ACTION_REWARD_TYPE_OPEN
import com.qihoo360.mobilesafe.reward.RewardConstant.Companion.ACTION_REWARD_TYPE_OPEN_DEEP_LINK
import com.qihoo360.mobilesafe.reward.RewardConstant.Companion.PAGE_REWARD_SCENE
import com.qihoo360.mobilesafe.reward.RewardConstant.Companion.REWARD_AD_UNIQUE_ID
import com.qihoo360.mobilesafe.reward.container.RewardContainer
import com.qihoo360.mobilesafe.reward.data.ApullItemWrapper
import com.qihoo360.mobilesafe.reward.data.RewardRecordManager
import com.qihoo360.mobilesafe.reward.data.RewardUtils
import com.qihoo360.mobilesafe.reward.ui.page.dialog.RewardDownloadDialog
import com.qihoo360.mobilesafe.reward.ui.page.dialog.RewardNewRulesDialog
import com.qihoo360.mobilesafe.reward.ui.page.dialog.RewardResultDialog
import com.qihoo360.mobilesafe.support.log.Logger
import com.qihoo360.mobilesafe.ui.common.other.CommonPopupWindow
import com.qihoo360.mobilesafe.ui.common.other.CommonUIUtils
import com.qihoo360.mobilesafe.utils.ResizableHelper
import com.qihoo360.newssdk.apull.page.ApullAdWebViewPage
import kotlinx.android.synthetic.main.page_raffle.*
import kotlinx.android.synthetic.main.page_raffle_error.*
import kotlinx.android.synthetic.main.page_raffle_hongbao_change.*
import java.util.*

open class RaffleActivity : RaffleBaseActivity(), ApullRewardVideoInterface {

    private  val TAG =  "RaffleActivity"
    var batteryQuantity = 0

    private val mRewardReceiver = RewardReceiver()
    private val mProcessReceiver = ProcessReceiver()

    private var mRewardContainer: RewardContainer? = null

    override fun setLayoutId(): Int  = R.layout.page_raffle

    private var rewardInfo:RewardUtils.RewardInfo? = null

    override fun initData() {
        super.initData()
        tryCatch {
            val mReceiverFilter = IntentFilter()
            mReceiverFilter.addAction(Intent.ACTION_BATTERY_CHANGED)
            mReceiverFilter.addAction(ACTION_REWARD_AD_NEWS_H5_CREATE)
            mReceiverFilter.addAction(ACTION_REWARD_TYPE_OPEN)
            mReceiverFilter.addAction(ACTION_REWARD_TYPE_OPEN_DEEP_LINK)
            mReceiverFilter.addAction(ACTION_QIHOO_NEWSDK_DOWNLOAD_ONSTARTINSTALLAPK)
            mReceiverFilter.addAction(ACTION_QIHOO_NEWSDK_DOWNLOAD_ONAPKINSTALLED)
            registerReceiver(mRewardReceiver,mReceiverFilter)

            val mProcessFilter = IntentFilter()
            mProcessFilter.addAction(ACTION_ACTIVITY_CHANGE_EVENT)
            LocalBroadcastManagerC.getInstance(this).registerReceiver(mProcessReceiver,mProcessFilter)
        }
    }

    override fun initDefaultData(){
        mFromIntentData.apply {

            if (mScene == 0) {
                mScene = PAGE_REWARD_SCENE
            }

            if (mTitle.isEmpty()) {
                mTitle = "抢现金红包"
            }

            if (mUrl.isEmpty()) {
                mUrl = "https://pop.shouji.360.cn/fe/sjws/redpacket/down_cash.html"
            }

            if (mPool.isEmpty()) {
                mPool = "syh"
            }
            if (mPromotionId.isEmpty()) {
                mPromotionId = "1"
            }
            if (mBackground.isEmpty()) {
                mBackground = "#dc2719"
            }
            if (mWxImgUrl.isEmpty()) {
                mWxImgUrl = "http://p0.qhimg.com/d/inn/106b6c8b/puq.png"
            }
            if (mWbImgUrl.isEmpty()) {
                mWbImgUrl = "http://p9.qhimg.com/d/inn/2a27ed0b/br.png"
            }
            if (mShareTitle.isEmpty()) {
                mShareTitle = "用@360优化手机 得现金红包可提现，"
            }
            if (mShareDesc.isEmpty()) {
                mShareDesc = "回馈忠实用户，360手机卫士1亿红包大放送，最高200元，可提现！"
            }
            Logger.d(TAG,"mScene = $mScene,mSubScene = $mSubScene,mTitle=$mTitle,mUrl=$mUrl," +
                    "mUrl=$mUrl,mPromotionId=$mPromotionId,mBackground=$mBackground,mWxImgUrl=$mWxImgUrl," +
                    "mWbImgUrl = $mWbImgUrl,mShareTitle=$mShareTitle,mShareDesc=$mShareDesc")

            ApullRewardInterfaceManager.add(mScene,mSubScene,this@RaffleActivity)
            initShareImgPath(this@RaffleActivity)
        }
    }

    private fun initShareImgPath(context: Context?){
        if(context == null)
            return
        val wbImgPath = FileDownloadManager.getInstance().getDownloadedFile(mFromIntentData.mWbImgUrl)
        if(wbImgPath.isNullOrEmpty()){
            downloadShareImgPath(context,mFromIntentData.mWbImgUrl)
        }else{
            mFromIntentData.wbImgPath = wbImgPath
        }

        val wxImgPath = FileDownloadManager.getInstance().getDownloadedFile(mFromIntentData.mWxImgUrl)
        if(wxImgPath.isNullOrEmpty()){
            downloadShareImgPath(context,mFromIntentData.mWxImgUrl)
        }else{
            mFromIntentData.wxImgPath = wxImgPath
        }
    }

    private fun downloadShareImgPath(context: Context?,url:String){
        Thread(Runnable {
            FileDownloadManager.getInstance().download(context, url, object : FileDownloadManager.Listener {

                override fun onDownloadSuccess(fileUrl: String, filePath: String) {
                    if(fileUrl == mFromIntentData.mWbImgUrl){
                        mFromIntentData.wbImgPath = filePath
                    }else if(fileUrl == mFromIntentData.mWxImgUrl){
                        mFromIntentData.wxImgPath = filePath
                    }
                }
                override fun onDownloadStart(fileUrl: String) {
                }

                override fun onDownloadFail(fileUrl: String) {
                }
            })
        }, "new-isi-1").start()
    }


    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        if(mFromIntentData.mSubScene < 2) {
            showRewardNewsRulesDialog()
        }
    }


    override fun initTitleView() {
        mHongBaoTitleBar?.height = 56
        mHongBaoTitleBar?.setTitle(mFromIntentData.mTitle)
        mHongBaoTitleBar?.setBackgroundColor(resources.getColor(R.color.hongbao_title_transparent))
        mHongBaoTitleBar?.setSettingImg(R.drawable.setting_button_image)
        mHongBaoTitleBar?.setOnSettingListener {

            mPopupWindow?.apply {
                tryCatch({

                }) {
                    mPopupWindow?.showAsDropDown(mHongBaoTitleBar.rightButton, -CommonUIUtils.dip2px(this@RaffleActivity, 120f), 0)
                }
            }?:kotlin.run {
                mPopupWindow = CommonPopupWindow(this@RaffleActivity)
                mPopupWindow?.setCheckVisible(false)
                mPopupWindow?.setWindowWidth(CommonUIUtils.dip2px(this@RaffleActivity, 150f))
                mPopupWindow?.setOnItemClickListener(ItemClickListener())
                val items = resources.getStringArray(R.array.hongbao_titlebar_array)
                mPopupWindow?.setItems(items)
                tryCatch({

                }) {
                    mPopupWindow?.showAsDropDown(mHongBaoTitleBar.rightButton, -CommonUIUtils.dip2px(this@RaffleActivity, 120f), 0)
                }
            }


        }
        mHongBaoTitleBar.setShareImg(R.drawable.hongbao_record)
        mHongBaoTitleBar.setOnShareListener {
            mPresenter.showRewardRecord()
        }
    }

    private inner class ItemClickListener : AdapterView.OnItemClickListener {
        override fun onItemClick(parent: AdapterView<*>?, view: View?, position: Int, id: Long) {
            when(position){
                0->{
                    val rewardBasicInfo = RewardUtils.RewardBasicInfo()
                    rewardBasicInfo.pool = mFromIntentData.mPool
                    rewardBasicInfo.promotionId = mFromIntentData.mPromotionId
                    rewardBasicInfo.wxImgPath = mFromIntentData.wxImgPath
                    rewardBasicInfo.wbImgPath = mFromIntentData.wbImgPath
                    rewardBasicInfo.shareTitle = mFromIntentData.mShareTitle
                    rewardBasicInfo.shareDesc = mFromIntentData.mShareDesc

                    val rewardInfo = RewardUtils.RewardInfo()
                    rewardInfo.shareInfo = ""
                    val share = RewardUtils.getSharedInfo(this@RaffleActivity)
                    if (share == 1) {
                        rewardInfo.shareInfo = "true"
                    }

                    rewardInfo.rewardBasicInfo = rewardBasicInfo
                    RewardUtils.startShareApp(this@RaffleActivity, rewardInfo)

                    RewardUtils.setSharedInfo(this@RaffleActivity, 1)
                }
                1->{
                    Factory.startActivity(view?.context, Intent(), "wallet", "com.qihoo360.mobilesafe.wallet.MainActivity", IPluginManager.PROCESS_AUTO)
                }
                2->{
                     val i = Intent()
                     i.putExtra(KEY_INITIAL_URL, "http://pop.shouji.360.cn/weishi/pop/rulered.html")
                    // i.putExtra("new_detail_extra_key_url", view?.context?.getString(R.string.hongbao_rules_title))
                     if(RewardSDK.mIsSingleApk){
                         i.setClass(view?.context,ApullAdWebViewPage::class.java)
                         view?.context?.startActivity(i)
                         return
                     }
                     Factory.startActivity(view?.context, i, "news", "com.qihoo360.newssdk.apull.page.ApullAdWebViewPage", IPluginManager.PROCESS_AUTO)
                }
            }
        }

    }

    private fun showRewardNewsRulesDialog() {
        var times = RewardRecordManager.getNewRulesDialogTime(this)
        if(times < 2){
            val mNewRulesDialog = RewardNewRulesDialog(this,0)
            mNewRulesDialog.show()
            times += 1
            RewardRecordManager.setNewRulesDialogTime(this,times)
        }else{
            var mRewardNoticeOpen = RewardConfigHelper.getRewardNoticeOpenType()
            var mRewardNoticeTimes = RewardConfigHelper.getRewardNoticeTimes()
            Logger.d(TAG, "mRewardNoticeOpen=$mRewardNoticeOpen,mRewardNoticeTimes=$mRewardNoticeTimes")
            if(mRewardNoticeOpen && mRewardNoticeTimes > 0) {//开状态且弹窗次数>0
                val mLastTimeStamps = RewardRecordManager.getRewardNoticeLastTimeStamps(this)
                val mCurrentTimeStamps = System.currentTimeMillis()
                var mTodayShowTimes = RewardRecordManager.getRewardNoticeTodayTimes(this)
                Logger.d(TAG,"mLastTimeStamps=$mLastTimeStamps,mCurrentTimeStamps=$mCurrentTimeStamps,mTodayShowTimes=$mTodayShowTimes")
                if (mLastTimeStamps == 0L) {
                    if(mRewardNoticeTimes > mTodayShowTimes) {
                        mTodayShowTimes++
                        RewardRecordManager.setRewardNoticeTodayTimes(this,mTodayShowTimes)
                        val mNewRulesDialog = RewardNewRulesDialog(this,1)
                        mNewRulesDialog.show()
                    }else{
                        Logger.d(TAG,"mRewardNoticeTime > mTodayShowTimes and do not show Rules Dialog")
                    }
                }else{
                    //判断是否是当前自然日
                    val calendar = Calendar.getInstance()
                    calendar.timeInMillis = mCurrentTimeStamps
                    val currentDay = calendar.get(Calendar.DAY_OF_MONTH)
                    calendar.timeInMillis = mLastTimeStamps
                    val lastDay = calendar.get(Calendar.DAY_OF_MONTH)
                    Logger.d(TAG,"currentDay=$currentDay,lastDay=$lastDay")
                    if(currentDay != lastDay){//第二天清零
                        RewardRecordManager.setRewardNoticeTodayTimes(this,0)
                    }
                    mTodayShowTimes = RewardRecordManager.getRewardNoticeTodayTimes(this)
                    if(mRewardNoticeTimes > mTodayShowTimes){
                        mTodayShowTimes++
                        RewardRecordManager.setRewardNoticeTodayTimes(this,mTodayShowTimes)
                        val mNewRulesDialog = RewardNewRulesDialog(this,1)
                        mNewRulesDialog.show()
                    }
                }
                RewardRecordManager.setRewardNoticeLastTimeStamps(this, mCurrentTimeStamps)
            }
        }
    }

    override fun onRewardResponse(mRewardView: View?,pageCount :Int) {
        super.onRewardResponse(mRewardView, pageCount)
        mRewardView?.apply {
            mRewardContainer = mRewardView as? RewardContainer?
            addRewardView(mRewardView)
            if (pageCount > 1) {
                mChangeBatch.setVisible(true)
                mChangeBatch.setOnClickListener{
                    switchOnNextPage()
                }
            }
        } ?: run {
            toast("加载失败")
            showErrorTips(true,Status.EMPTY)
        }
    }

    open fun addRewardView(mRewardView: View){
        showContentList(true)

        val viewParent = mAppListLayout?.parent
        if (viewParent != null) {
            val parent = viewParent as ViewGroup
            val index = parent.indexOfChild(mAppListLayout)
            parent.removeViewInLayout(mAppListLayout)
            mRewardView.id = mAppListLayout.id

            val params = mAppListLayout.layoutParams
            if (params != null) {
                parent.addView(mRewardView, index, params)
            } else {
                parent.addView(mRewardView, index)
            }
        } else {
            mAppListLayout?.addView(mRewardView)
        }
    }

    /**
     * 换一换逻辑
     */
    private fun switchOnNextPage() {
        mRewardContainer?.apply {
            mRewardContainer?.updatePageIndexView()
        }
    }

    override fun onClick(v: View?) {
        when(v?.id){
            R.id.mErrorRetry->{
                requestRewardAd()
            }
        }
    }

    override fun onRewardTimeOut() {
        super.onRewardTimeOut()
        showErrorTips(true,Status.TIMEOUT)
    }

    override fun requestRewardAd() {
        if(NetUtil.isConnected(this@RaffleActivity)) {
            super.requestRewardAd()
            mPresenter.requestRewardAd(this@RaffleActivity, mFromIntentData.mScene, mFromIntentData.mSubScene,
                    mFromIntentData.mReferScene, mFromIntentData.mReferSubScene)
        }else{
            showErrorTips(true,Status.NET)
        }
    }

    private fun showContentList(show: Boolean){
         val mErrorViewStub = findViewById(R.id.mContent) as? ViewStub
         mErrorViewStub?.inflate()

         val mContentViewStub = findViewById(R.id.mError) as? ViewStub
         mContentViewStub?.inflate()

         if(show){
             mErrorLayout?.setVisible(false)
             mContentLayout?.setVisible(true)
         }else{
             mErrorLayout?.setVisible(true)
             mContentLayout?.setVisible(false)
         }
     }

    private fun showErrorTips(show: Boolean, status: Status) {
        val mErrorViewStub = findViewById(R.id.mContent) as? ViewStub
        mErrorViewStub?.inflate()

        val mContentViewStub = findViewById(R.id.mError) as? ViewStub
        mContentViewStub?.inflate()

        mErrorLayout?.setVisible(show)
        if(show){
            when(status){
                Status.EMPTY -> {
                    mErrorTitle?.text = getString(R.string.apullsdk_hongbao_data_error_title)
                    mErrorTips.text = getString(R.string.apullsdk_hongbao_data_error_tips)
                }
                Status.NET -> {
                    mErrorTitle?.text = getString(R.string.apullsdk_hongbao_net_error_title)
                    mErrorTips?.text = getString(R.string.apullsdk_hongbao_net_error_tips)
                }
                Status.TIMEOUT -> {
                    mErrorTitle?.text = getString(R.string.apullsdk_hongbao_timeout_error_title)
                    mErrorTips?.text = getString(R.string.apullsdk_hongbao_timeout_error_title)
                }
                else -> {
                    mErrorTitle?.text = getString(R.string.apullsdk_hongbao_net_error_title)
                    mErrorTips?.text = getString(R.string.apullsdk_hongbao_net_error_tips)
                }
            }
        }
        mErrorRetry?.setOnClickListener(this@RaffleActivity)
    }

    override fun onResume() {
        super.onResume()
        refreshTryResultStatus()
        mPresenter.startCheckRewardChanceOnResume()
    }

    override fun showRewardDownloadDialog(apullItemWrapper: ApullItemWrapper,
                                          mDownloadListener: RewardDownloadDialog.DownloadListener) {
        tryCatch({
            Logger.d(TAG,"showRewardDownloadDialog")
            Logger.handleException(it)
        }){
            mRewardDownloadDialog?.apply {
                if(!apullItemWrapper.equalsUniqueId(mRewardDownloadDialog?.getApullItemWrapper())){
                    mRewardDownloadDialog = RewardDownloadDialog(this@RaffleActivity,apullItemWrapper,mDownloadListener)
                }
                if(!isShowing){
                  show()
                }
            }?:run{
                mRewardDownloadDialog = RewardDownloadDialog(this@RaffleActivity,apullItemWrapper,mDownloadListener)
                mRewardDownloadDialog?.show()
            }
        }

    }

    override fun showChanceResultDownloadDialog(rewardInfo : RewardUtils.RewardInfo?) {
        tryCatch({
            Logger.d(TAG,"updateRewardDownloadDialogStatus")
            Logger.handleException(it)
        }){
            mRewardDownloadDialog?.apply {
                if(rewardInfo?.apullAdItem != null) {
                    if (!rewardInfo.apullAdItem.equalsUniqueId(mRewardDownloadDialog?.getApullItemWrapper())) {
                        mRewardDownloadDialog = RewardDownloadDialog(this@RaffleActivity, rewardInfo.apullAdItem, null)
                    }
                }

                if(mRewardCome && rewardInfo?.hasRewardOpenChance()== true){
                    mRewardResultDialog?.apply {
                        Logger.d(TAG,"showChanceResultDownloadDialog mRewardResultDialog not null")
                        if(mRewardResultDialog?.isShowing == true) {
                            Logger.d(TAG,"showChanceResultDownloadDialog mRewardResultDialog is showing")
                            mRewardResultDialog?.dismiss()
                        }
                        mRewardResultDialog = null
                    }
                }

                if(!isShowing) {
                    show()
                }
                updateSuccessRewardInfo(rewardInfo)

            } ?: run{
                mRewardDownloadDialog = RewardDownloadDialog(this@RaffleActivity, rewardInfo?.apullAdItem, null)
                mRewardDownloadDialog?.show()
                mRewardDownloadDialog?.updateSuccessRewardInfo(rewardInfo)
            }
        }
    }

    override fun showFailResultDownloadDialog(rewardInfo: RewardUtils.RewardInfo?, status: Int, rewardType: Int) {
        tryCatch({
            Logger.d(TAG,"updateRewardDownloadDialogStatus")
            Logger.handleException(it)
        }){
            mRewardDownloadDialog?.apply {
                if(rewardInfo?.apullAdItem != null) {
                    if (!rewardInfo.apullAdItem.equalsUniqueId(mRewardDownloadDialog?.getApullItemWrapper())) {
                        mRewardDownloadDialog = RewardDownloadDialog(this@RaffleActivity, rewardInfo.apullAdItem, null)
                    }
                }
                if(!isShowing) {
                    show()
                }
                updateFailRewardInfo(rewardInfo,status,rewardType)

            } ?: run{
                mRewardDownloadDialog = RewardDownloadDialog(this@RaffleActivity, rewardInfo?.apullAdItem, null)
                mRewardDownloadDialog?.show()
                mRewardDownloadDialog?.updateFailRewardInfo(rewardInfo,status,rewardType)
            }
        }
    }

    override fun showRewardResultDialog(rewardInfo: RewardUtils.RewardInfo?,succeed:Boolean,shareCanTryAgain: Boolean) {
        tryCatch({
            Logger.d(TAG,"handleRewardCommit")
            Logger.handleException(it)
        }){
            mRewardDownloadDialog?.apply {
                if(mRewardCome && mRewardInfo?.hasRewardOpenChance() == true) {
                    mRewardResultDialog?.apply {
                        Logger.d(TAG,"showRewardResultDialog mRewardResultDialog not null")
                        if(isShowing){
                            Logger.d(TAG,"showRewardResultDialog mRewardResultDialog is showing")
                            dismiss()
                        }
                        mRewardResultDialog = null
                    }
                }
            }

            mRewardResultDialog?.apply {
                mRewardResultDialog?.updateRewardInfo(rewardInfo,succeed,shareCanTryAgain)
                if(!isShowing){
                    show()
                }
            }?:run {
                mRewardResultDialog = RewardResultDialog(this,rewardInfo,succeed,shareCanTryAgain)
                mRewardResultDialog?.show()
            }
        }
    }


    override fun startRewardCommit(rewardInfo: RewardUtils.RewardInfo?) {
        tryCatch({
            Logger.d(TAG,"handleRewardCommit")
            Logger.handleException(it)
        }){
           mPresenter.startRewardCommit(rewardInfo)
        }
    }

    override fun dismissRewardDownloadDialog() {
       tryCatch{
           mRewardDownloadDialog?.apply {
               if(mRewardDownloadDialog?.isShowing == true) {
                   mRewardDownloadDialog?.dismiss()
               }
               mRewardDownloadDialog = null
           }
           mRewardResultDialog?.apply {
               if(mRewardResultDialog?.isShowing == true) {
                   mRewardResultDialog?.dismiss()
               }
               mRewardResultDialog = null
           }

       }
    }

    override fun onBackPressedDownDialog(rewardInfo: RewardUtils.RewardInfo?) {
       tryCatch {
           mPresenter.onBackPressedDownDialog(rewardInfo)
           dismissRewardDownloadDialog()
       }
    }

    override fun refreshTryResultStatus(mRewardInfo: RewardUtils.RewardInfo?) {
        super.refreshTryResultStatus(mRewardInfo)

        if(mRewardInfo == null){
            return
        }
        rewardInfo = mRewardInfo
        refreshTryResultStatus()
    }


    private fun refreshTryResultStatus(){
        if(rewardInfo == null)
            return
        val shared = RewardUtils.getSharedInfo(this)

        val status = rewardInfo?.tryResponse?.result
        val chance = rewardInfo?.tryResponse?.chances ?:0
        val tryShared = rewardInfo?.tryResponse?.share ?:0

        if (status == RewardUtils.STATUS_REWARD_CLOSE) {
            mContentTips.setVisible(true)
            mContentTips.setText(R.string.hongbao_tip_today_end)
        } else if (status == RewardUtils.STATUS_REWARD_NO
                || status == RewardUtils.STATUS_REWARD_YES) {
            if (chance > 0) {
                mContentTips.setVisible(false)
            } else {
                if (tryShared > 0) {
                    if (shared > 0) {
                        mContentTips.setVisible(false)
                    } else {
                        mContentTips.setVisible(true)
                        mContentTips.setText(R.string.hongbao_tip_share_more)
                    }
                } else {
                    mContentTips.setVisible(true)
                    mContentTips.setText(R.string.hongbao_tip_today_nochance)
                }
            }
        }
    }

   private inner class RewardReceiver : BroadcastReceiver(){
        override fun onReceive(context: Context?, intent: Intent?) {

            intent?.run {
                Logger.d(TAG, "RewardReceiver: : $action")
                when(action){
                    ACTION_QIHOO_NEWSDK_DOWNLOAD_ONSTARTINSTALLAPK->{
                        val downloadId = getStringExtra(ApullActionConst.KEY_RESULT_DOWNLOAD_ID)
                        mPresenter.handleWorkingPackage(downloadId)
                    }
                    ACTION_QIHOO_NEWSDK_DOWNLOAD_ONAPKINSTALLED ->{
                        val downloadId = getStringExtra(ApullActionConst.KEY_RESULT_DOWNLOAD_ID)
                        mFromIntentData.mBatteryQuantity = batteryQuantity
                        mPresenter.handlePackageInstalled(downloadId,mFromIntentData)
                    }
                    Intent.ACTION_BATTERY_CHANGED ->{
                        val level = getIntExtra("level",0)
                        val scale = getIntExtra("scale",100)
                        batteryQuantity = level * 100 / scale
                    }

                    ACTION_REWARD_AD_NEWS_H5_CREATE ->{
                        //WebView创建成功时，notify红包信息
                        val uniqueId = getStringExtra(REWARD_AD_UNIQUE_ID)
                        mPresenter.notifyTryResponse(uniqueId)
                    }
                    ACTION_REWARD_TYPE_OPEN ->{
                        val uniqueId = getStringExtra(REWARD_AD_UNIQUE_ID)
                        mPresenter.handleWorkingPackage(uniqueId)
                        mFromIntentData.mBatteryQuantity = batteryQuantity
                        mPresenter.handlePackageInstalled(uniqueId,mFromIntentData,RewardUtils.REWARD_TYPE_OPEN)
                    }
                    ACTION_REWARD_TYPE_OPEN_DEEP_LINK ->{
                        val uniqueId = getStringExtra(REWARD_AD_UNIQUE_ID)
                        mPresenter.handleWorkingPackage(uniqueId)
                        mFromIntentData.mBatteryQuantity = batteryQuantity
                        mPresenter.handlePackageInstalled(uniqueId,mFromIntentData,RewardUtils.REWARD_TYPE_OPEN_DEEP_LINK)
                    }
                }
            }
        }

    }

    private inner class ProcessReceiver : BroadcastReceiver(){
        override fun onReceive(context: Context?, intent: Intent?) {
            intent?.run {
                Logger.d(TAG, "ProcessReceiver: : $action")
                when(action){
                    ACTION_ACTIVITY_CHANGE_EVENT ->{
                        val pkgName = getStringExtra("packageName")
                        mPresenter.computeAppActiveTime(pkgName)
                    }
                }
            }
        }

    }

    override fun onDestroy() {
        super.onDestroy()
        tryCatch {
            LocalBroadcastManagerC.getInstance(this).unregisterReceiver(mProcessReceiver)
            unregisterReceiver(mRewardReceiver)
            ApullRewardInterfaceManager.remove(mFromIntentData.mScene,mFromIntentData.mSubScene)
            mPresenter.onDestroy()
        }
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        mPresenter.onActivityResult(requestCode,resultCode,data)
    }

    override fun onKeyDown(keyCode: Int, event: KeyEvent?): Boolean {
        tryCatch {
            if(keyCode == KeyEvent.KEYCODE_BACK){
                if(mPresenter.backKeyDown()){
                    return true
                }
            }
        }
        return super.onKeyDown(keyCode, event)
    }

    override fun onVideoPlayComplete(json: String?) {
        Logger.d(TAG,"onVideoPlayComplete : $json")
        mPresenter.handleRewardVideoResult(json)
    }

}