package com.qihoo360.mobilesafe.reward.ui.page

import android.content.BroadcastReceiver
import android.content.Context
import android.content.Intent
import android.content.IntentFilter
import android.graphics.Color
import android.os.Bundle
import android.os.Handler
import android.support.v4.content.LocalBroadcastManager
import android.text.TextUtils
import android.view.Gravity
import android.widget.LinearLayout
import android.widget.Toast
import com.nostra13.universalimageloader.core.ImageLoader
import com.qihoo360.apullsdk.apull.ApullConst
import com.qihoo360.apullsdk.apull.control.sync.DownloadSatusManager
import com.qihoo360.apullsdk.apull.control.sync.DownloadSyncInterface
import com.qihoo360.apullsdk.apull.protocol.ApullReportManager
import com.qihoo360.apullsdk.apull.protocol.model.impl.TemplateApullApp
import com.qihoo360.apullsdk.apull.protocol.model.impl.app.ApullAppItem
import com.qihoo360.apullsdk.apull.view.utils.ApullDownloadUtil
import com.qihoo360.apullsdk.apull.view.utils.ApullTextPatchUtil
import com.qihoo360.apullsdk.support.cache.ApullTemplateCacheUtil
import com.qihoo360.apullsdk.support.imageconfig.ImageDownloaderConfig
import com.qihoo360.apullsdk.ui.common.DialogPopupWindow
import com.qihoo360.apullsdk.utils.BitmapUtil
import com.qihoo360.apullsdk.utils.DensityUtil
import com.qihoo360.apullsdk.utils.NetUtil
import com.qihoo360.apullsdk.utils.PackageUtil
import com.qihoo360.framework.base.IKillable
import com.qihoo360.mobilesafe.authguide.service.AuthConst
import com.qihoo360.mobilesafe.authguide.service.AuthGuideServiceHelper
import com.qihoo360.mobilesafe.extension.toast
import com.qihoo360.mobilesafe.extension.tryCatch
import com.qihoo360.mobilesafe.reward.R
import com.qihoo360.mobilesafe.reward.data.ApullItemWrapper
import com.qihoo360.mobilesafe.reward.utils.PluginCmdProxy
import com.qihoo360.mobilesafe.reward.utils.RewardCmdHandle
import com.qihoo360.mobilesafe.support.log.Logger
import com.qihoo360.newssdk.apull.page.BaseActivity
import kotlinx.android.synthetic.main.page_reward_twice.*

class RewardTwiceActivity : BaseActivity(),IKillable, DownloadSyncInterface {


    companion object {
        var DEBUG = Logger.bDebug()
        const val TAG = "RewardTwiceActivity"
        const val REWARD_TWICE_TEMPLATE = "reward_twice_Template"
    }

    private var mApullAppTemplate : TemplateApullApp? = null

    private var mApullAppItem :ApullAppItem? = null

    private var mHandler = Handler()

    private val mDialogReceiver = object : BroadcastReceiver() {
        override fun onReceive(context: Context, intent: Intent) {
            LocalBroadcastManager.getInstance(this@RewardTwiceActivity).unregisterReceiver(this)
            val action = intent.action
            if (TextUtils.isEmpty(action)) {
                return
            }

            val bOk = intent.getBooleanExtra(DialogPopupWindow.ACTION_DIALOG_RET_EXT, false)
            if (bOk) {
                if (action == DialogPopupWindow.ACTION_DIALOG_NET_PRE + mApullAppTemplate?.downloadid) {
                    downloadApp()
                } else if (action == DialogPopupWindow.ACTION_DIALOG_CANCEL_PRE + mApullAppTemplate?.downloadid) {
                    cancelDownloadApp()
                }
            }
        }
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.page_reward_twice)
        mTwiceRoot.setBackgroundColor(Color.parseColor("#ffffff"))

        if(!initData() || mApullAppTemplate == null || mApullAppItem == null){
            finish()
            return
        }

        initView()
        updateProgress()
        DownloadSatusManager.register(this)

    }

    private fun initView() {
        mTwiceTitle?.height = 56
        mTwiceTitle?.setTitle("返回")
        mTwiceTitle?.setBackgroundColor(Color.parseColor("#2c2c35"))

        tryCatch {
            if(mTwiceLargeImage?.layoutParams != null){
                var width = mTwiceLargeImage?.layoutParams!!.width
                var height = mTwiceLargeImage?.layoutParams!!.height
                if(width == -1 && mTwiceLargeImage?.layoutParams is LinearLayout.LayoutParams){
                    val marginLeft = (mTwiceLargeImage?.layoutParams as? LinearLayout.LayoutParams)?.leftMargin ?:0
                    val marginRight = (mTwiceLargeImage?.layoutParams as? LinearLayout.LayoutParams)?.rightMargin?:0
                    width = DensityUtil.getScreenWidth(this ) - marginLeft - marginRight
                }

                ImageLoader.getInstance().displayImage(mApullAppItem?.large_image_url,mTwiceLargeImage,
                        ImageDownloaderConfig.getDefaultRoundFitXYIconOptions(this,DensityUtil.px2dip(this, width.toFloat()),
                                DensityUtil.px2dip(this, height.toFloat()),5,DensityUtil.px2dip(this, 1.0f)))
            }

            mTwiceAddesc?.text = mApullAppItem?.short_desc

            mTwiceRule?.text = mApullAppItem?.rule


            mTextProgressBar?.setTextColor(resources.getColor(R.color.common_font_color_7))
            var drawable = BitmapUtil.createSolidDrawable(this, DensityUtil.dip2px(this, 5f),
                    0, Color.parseColor("#fb4040"), false)
            mTextProgressBar?.setBackgroundDrawable(drawable)
            drawable = BitmapUtil.createSolidDrawable(this, DensityUtil.dip2px(this, 5f),
                    0, Color.parseColor("#fd6262"), true)
            mTextProgressBar?.progressDrawable = drawable
            mTextProgressBar?.setTextDimen(resources.getDimensionPixelSize(R.dimen.common_font_size_d).toFloat())
            mTextProgressBar?.setOnClickListener { handleAppClick() }
        }
    }

    private fun handleAppClick() {
        Logger.d(TAG,"handleAppClick")

        // 如果已经安装，更新下状态
        if (!mApullAppItem?.pkgname.isNullOrEmpty() && PackageUtil.isPkgInstalled(this, mApullAppItem?.pkgname)) {
            if (mApullAppItem?.filter_type == 0) {
                mApullAppItem?.status = ApullConst.STATUS_TYPE_INSTALL_FINISHED
            }
        }

        if (mApullAppItem?.status == ApullConst.STATUS_TYPE_DOWNLOAD ||
                mApullAppItem?.status == ApullConst.STATUS_TYPE_DOWNLOAD_PAUSED ||
                mApullAppItem?.status == ApullConst.STATUS_TYPE_DOWNLOAD_CANCELED ||
                mApullAppItem?.status == ApullConst.STATUS_TYPE_DOWNLOAD_DELETED ||
                mApullAppItem?.status == ApullConst.STATUS_TYPE_DOWNLOAD_FAILED ||
                mApullAppItem?.status == ApullConst.STATUS_TYPE_DOWNLOAD_FINISHED ||
                mApullAppItem?.status == ApullConst.STATUS_TYPE_INSTALL) {
            downloadAppWithCheckNet()
        } else if (mApullAppItem?.status == ApullConst.STATUS_TYPE_DOWNLOADING ||
                mApullAppItem?.status == ApullConst.STATUS_TYPE_UPDATE_PROGRESS) {
            pauseDownloadApp()
        } else if (mApullAppItem?.status == ApullConst.STATUS_TYPE_INSTALL_FINISHED) {
            openApp()
        }
    }

    private fun pauseDownloadApp() {
        tryCatch {
            mApullAppTemplate?.apply {
                // 数据上报
                if (mApullAppTemplate?.paused_reported == false) {
                    mApullAppTemplate?.paused_reported = true
                    ApullReportManager.reportApullSspAppPaused(this@RewardTwiceActivity, mApullAppTemplate)
                }

                // 执行
                ApullDownloadUtil.pauseDownloadApp(this@RewardTwiceActivity, mApullAppTemplate, mApullAppItem)


                val msg = this@RewardTwiceActivity.resources.getString(R.string.hongbao_app_pause_downloading, mApullAppItem?.app_name)
                this@RewardTwiceActivity.toast(msg)
            }
        }

    }

    private fun cancelDownloadApp() {
        tryCatch {
            mApullAppTemplate?.apply {
                // 数据上报
                if (mApullAppTemplate?.canceled_reported == false) {
                    mApullAppTemplate?.canceled_reported = true
                    ApullReportManager.reportApullSspAppCanceled(this@RewardTwiceActivity, mApullAppTemplate)
                }

                // 执行
                ApullDownloadUtil.cancelDownloadApp(this@RewardTwiceActivity, mApullAppTemplate, mApullAppItem)

                // toast提示
                val msg = this@RewardTwiceActivity.resources.getString(R.string.hongbao_app_cancel_downloading,mApullAppItem?.app_name)
                this@RewardTwiceActivity.toast(msg)
            }
        }

    }

    private fun downloadAppWithCheckNet() {
        if(mApullAppItem == null)
            return
        if (NetUtil.isConnected(this)) {
            if (!NetUtil.isWifiConnected(this)) {
                val title = getString(R.string.tips_title)
                val body = getString(R.string.tips_body_start_download)


                val action =DialogPopupWindow.ACTION_DIALOG_NET_PRE + mApullAppTemplate?.downloadid
                val popupWindow = DialogPopupWindow(this, title, body,  action)
                popupWindow.setPopupBtnText("继续","取消")
                try {
                    popupWindow.showAtLocation(mTwiceRoot, Gravity.CENTER, 0, 0)
                } catch (e: Throwable) {
                    //
                }

                LocalBroadcastManager.getInstance(this).registerReceiver(mDialogReceiver, IntentFilter(action))
            } else {
                downloadApp()
            }
        } else {
            Toast.makeText(this, R.string.hongbao_net_no_connect_tips, Toast.LENGTH_SHORT).show()
        }
    }

    private fun downloadApp() {
        tryCatch {
            // 数据上报
            mApullAppTemplate?.apply {
                if (!mApullAppTemplate!!.click_reported) {
                    mApullAppTemplate!!.click_reported = true
                    ApullTemplateCacheUtil.refresh(mApullAppTemplate)
                    ApullReportManager.reportApullSspAppClick(this@RewardTwiceActivity, mApullAppTemplate)
                    ApullReportManager.reportApullDjAppClick(this@RewardTwiceActivity, mApullAppTemplate)
                }
            }

            AuthGuideServiceHelper.requestAuth(this, AuthConst.AUTH_CODE_WRITE_EXTERNAL_STORAGE)

            ApullDownloadUtil.startDownloadApp(this, mApullAppTemplate, mApullAppItem)
        }

    }


     fun updateView() {
        // 数据上报
         mApullAppTemplate?.apply {
             when (mApullAppItem?.status) {
                 ApullConst.STATUS_TYPE_DOWNLOADING ->
                     // 数据上报
                     if (mApullAppTemplate?.click_reported == false) {
                         mApullAppTemplate?.click_reported = true
                         ApullReportManager.reportApullDjAppClick(this@RewardTwiceActivity,mApullAppTemplate)
                         ApullReportManager.reportApullSspClick(this@RewardTwiceActivity,mApullAppTemplate)

                     }
                 ApullConst.STATUS_TYPE_DOWNLOAD_FINISHED ->
                     // 数据上报
                     if (mApullAppTemplate?.downloaded_reported == false) {
                         mApullAppTemplate?.downloaded_reported = true
                         ApullReportManager.reportApullSspAppDownloaded(this@RewardTwiceActivity,mApullAppTemplate)
                     }
                 ApullConst.STATUS_TYPE_INSTALL_FINISHED -> {
                     // 数据上报
                     if (mApullAppTemplate?.installed_reported == false) {
                         mApullAppTemplate?.installed_reported = true
                         ApullReportManager.reportApullSspAppInstalled(this@RewardTwiceActivity,mApullAppTemplate)
                     }

                     // root安装后的应用，在ui进程，有自动执行命令自动执行
                     if (mApullAppItem?.iType == 2 &&
                             !TextUtils.isEmpty(mApullAppItem?.auto_extra_info_ui) &&
                             mApullAppTemplate?.auto_opened_reported == false) {
                         mApullAppTemplate?.auto_opened_reported = true
                         ApullReportManager.reportApullSspAppAutoOpened(this@RewardTwiceActivity,mApullAppTemplate)
                         PluginCmdProxy.applyCmd(this@RewardTwiceActivity, mApullAppTemplate,mApullAppItem?.auto_extra_info_ui)
                     }
                 }
             }

             mHandler.post { updateProgress() }
         }

    }

    private fun updateProgress() {

        Logger.d(TAG, "update status:" + mApullAppItem?.status + " packageName:" + mApullAppItem?.pkgname + " name = " + mApullAppItem?.app_name)
        if (mTextProgressBar != null) {
            when (mApullAppItem?.status) {
                ApullConst.STATUS_TYPE_DOWNLOAD -> if (!TextUtils.isEmpty(mApullAppItem?.button_text)) {
                    mTextProgressBar?.setText(ApullTextPatchUtil.getFormatText(this, mApullAppItem?.button_text, mApullAppItem?.button_text_patch).toString(), 0)
                } else {
                    mTextProgressBar?.setText(resources.getString(R.string.download), 0)
                }
                ApullConst.STATUS_TYPE_DOWNLOADING -> mTextProgressBar?.setText(resources.getString(R.string.downloading), 0)
                ApullConst.STATUS_TYPE_UPDATE_PROGRESS -> mTextProgressBar?.setText(mApullAppItem?.progress.toString() + "%", mApullAppItem?.progress ?:0)
                ApullConst.STATUS_TYPE_DOWNLOAD_PAUSED -> mTextProgressBar?.setText(resources.getString(R.string.resume), mApullAppItem?.progress ?:0)
                ApullConst.STATUS_TYPE_DOWNLOAD_CANCELED -> if (!TextUtils.isEmpty(mApullAppItem?.button_text)) {
                    mTextProgressBar?.setText(ApullTextPatchUtil.getFormatText(this, mApullAppItem?.button_text, mApullAppItem?.button_text_patch)?.toString(), 0)
                } else {
                    mTextProgressBar?.setText(resources.getString(R.string.download), 0)
                }
                ApullConst.STATUS_TYPE_DOWNLOAD_DELETED -> if (!TextUtils.isEmpty(mApullAppItem?.button_text)) {
                    mTextProgressBar?.setText(ApullTextPatchUtil.getFormatText(this, mApullAppItem?.button_text, mApullAppItem?.button_text_patch)?.toString(), 0)
                } else {
                    mTextProgressBar?.setText(resources.getString(R.string.download), 0)
                }
                ApullConst.STATUS_TYPE_DOWNLOAD_FAILED -> if (!TextUtils.isEmpty(mApullAppItem?.button_text
                        )) {
                    mTextProgressBar?.setText(ApullTextPatchUtil.getFormatText(this, mApullAppItem?.button_text, mApullAppItem?.button_text_patch)?.toString(), 0)
                } else {
                    mTextProgressBar?.setText(resources.getString(R.string.download), 0)
                }
                ApullConst.STATUS_TYPE_DOWNLOAD_FINISHED -> {
                    mTextProgressBar?.setText(resources.getString(R.string.install), mApullAppItem?.progress ?:0)
                }
                ApullConst.STATUS_TYPE_INSTALL -> {
                    mTextProgressBar?.setText(resources.getString(R.string.install), mApullAppItem?.progress ?:0)
                    updateButtonStyleStateOpen()
                }
                ApullConst.STATUS_TYPE_INSTALLING -> {
                    mTextProgressBar?.setText(resources.getString(R.string.installing), mApullAppItem?.progress ?:0)
                    updateButtonStyleStateOpen()
                }
                ApullConst.STATUS_TYPE_INSTALL_FAILED -> {
                    mTextProgressBar?.setText(resources.getString(R.string.install), mApullAppItem?.progress ?:0)
                    updateButtonStyleStateOpen()
                }
                ApullConst.STATUS_TYPE_INSTALL_FINISHED -> {
                    mTextProgressBar?.setText(resources.getString(R.string.open), mApullAppItem?.progress ?:0)
                    updateButtonStyleStateOpen()
                }
                ApullConst.STATUS_TYPE_APK_OPENED -> {
                }
            }
        }
    }

    private fun updateButtonStyleStateOpen() {
        val drawable = BitmapUtil.createSolidDrawable(this, DensityUtil.dip2px(this, 5f),
                0, Color.parseColor("#fd6262"), false)
        mTextProgressBar?.progressDrawable = drawable
        mTextProgressBar?.setTextColor(resources.getColor(R.color.common_font_color_7))
    }

    private fun initData(): Boolean {
        tryCatch ({
            Logger.d(TAG,"initData")
            return false
        }){
            val intent = intent ?: return false
            val bundle = intent.extras ?: return false

            mApullAppTemplate = TemplateApullApp.createFromJsonString(bundle.getString(REWARD_TWICE_TEMPLATE))
            mApullAppTemplate?.apply {
               val mApullItemWrapper = ApullItemWrapper(mApullAppTemplate!!)
               mApullAppItem = mApullItemWrapper.getDefaultItem(false) as? ApullAppItem
            }
            return true
        }
        return false

    }

    private fun openApp() {
        tryCatch {
            Logger.d(TAG, "openApp")
            //数据上报
            if(mApullAppTemplate?.opened_reported == false){
                mApullAppTemplate?.opened_reported = true
                ApullReportManager.reportApullSspOpened(this@RewardTwiceActivity,mApullAppTemplate)
            }
            //打开
            val applyResult = PluginCmdProxy.applyCmd(this,mApullAppTemplate,mApullAppItem?.ad_extra_info)
            if (!applyResult) {
                RewardCmdHandle.openAppWithCustom(this, mApullAppItem?.pkgname!!)
            }
        }
    }

    override fun isKillable(): Boolean {
        return false
    }

    override fun onDownload(downloadid: String?) {
        mApullAppTemplate?.apply {
            if (mApullAppTemplate?.downloadid == downloadid) {
                mApullAppItem?.status = ApullConst.STATUS_TYPE_DOWNLOAD
                updateView()
            }
        }
    }

    override fun onProgressUpdate(downloadid: String?, progress: Int, filePath: String?) {
        mApullAppTemplate?.apply {
            if (mApullAppTemplate?.downloadid == downloadid) {
                mApullAppItem?.progress = progress
                mApullAppItem?.status = ApullConst.STATUS_TYPE_UPDATE_PROGRESS
                updateView()
            }
        }
    }

    override fun onDownloadFinished(downloadid: String?, filePath: String?) {
        mApullAppTemplate?.apply {
            if (mApullAppTemplate?.downloadid == downloadid) {
                mApullAppItem?.status =  ApullConst.STATUS_TYPE_DOWNLOAD_FINISHED
                updateView()
            }
        }
    }

    override fun onDownloadFailed(downloadid: String?, errorCode: Int) {
        mApullAppTemplate?.apply {
            if (mApullAppTemplate?.downloadid == downloadid) {
                mApullAppItem?.status = ApullConst.STATUS_TYPE_DOWNLOAD_FAILED
                updateView()
            }
        }
    }

    override fun onDownloadPaused(downloadid: String?) {
        mApullAppTemplate?.apply {
            if (mApullAppTemplate?.downloadid == downloadid) {
                mApullAppItem?.status = ApullConst.STATUS_TYPE_DOWNLOAD_PAUSED
                updateView()
            }
        }
    }

    override fun onDownloadResumed(downloadid: String?) {
        mApullAppTemplate?.apply {
            if (mApullAppTemplate?.downloadid == downloadid) {
                mApullAppItem?.status = ApullConst.STATUS_TYPE_DOWNLOAD
                updateView()
            }
        }
    }

    override fun onDownloadCanceled(downloadid: String?) {
        mApullAppTemplate?.apply {
            if (mApullAppTemplate?.downloadid == downloadid) {
                mApullAppItem?.status = ApullConst.STATUS_TYPE_DOWNLOAD_CANCELED
                updateView()
            }
        }
    }

    override fun onStartInstallApk(downloadid: String?) {
        mApullAppTemplate?.apply {
            if (mApullAppTemplate?.downloadid == downloadid) {
                mApullAppItem?.status = ApullConst.STATUS_TYPE_INSTALL
                updateView()
            }
        }
    }

    override fun onInstallingApk(downloadid: String?) {
        mApullAppTemplate?.apply {
            if (mApullAppTemplate?.downloadid == downloadid) {
                mApullAppItem?.status = ApullConst.STATUS_TYPE_INSTALLING
                updateView()
            }
        }
    }

    override fun onApkInstalled(downloadid: String?, iType: Int) {
        mApullAppTemplate?.apply {
            if (mApullAppTemplate?.downloadid == downloadid) {
                mApullAppItem?.iType = iType
                mApullAppItem?.status = ApullConst.STATUS_TYPE_INSTALL_FINISHED
                updateView()
            }
        }
    }

    override fun onApkInstallFailed(downloadid: String?) {
        mApullAppTemplate?.apply {
            if (mApullAppTemplate?.downloadid == downloadid) {
                mApullAppItem?.status = ApullConst.STATUS_TYPE_INSTALL_FAILED
                updateView()
            }
        }
    }
}